@use "../sable";

.container {
  // xs (extra small)
  @include sable.size-width(100%);
  // sm (small)
  @media only screen and (min-width: 640px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(640, 0.96) * 1px);
  }
  // md (medium)
  @media only screen and (min-width: 768px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(768, 0.94) * 1px);
  }
  // lg (large) 
  @media only screen and (min-width: 1024px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(1024, 0.92) * 1px);
  }
  // xl (extra large)
  @media only screen and (min-width: 1280px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(1280, 0.9) * 1px);
  }
  // 2xl (extra extra large)
  @media only screen and (min-width: 1536px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(1536, 0.88) * 1px);
  }
  // 3xl
  @media only screen and (min-width: 1920px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(1920, 0.86) * 1px);
  }
  // 4xl
  @media only screen and (min-width: 2560px) {
    @include sable.size-max-width(sable.fun-multiWithCeiling(2560, 0.84) * 1px);
  }
}

.block,
.before\:block::before,
.after\:block::after {
  @include sable.layo-display(block);
}
.inline,
.before\:inline::before,
.after\:inline::after {
  @include sable.layo-display(inline);
}
.inline-block,
.before\:inline-block::before,
.after\:inline-block::after {
  @include sable.layo-display(inline-block);
}
.flex,
.before\:flex::before,
.after\:flex::after {
  @include sable.layo-display(flex);
}
.inline-flex,
.before\:inline-flex::before,
.after\:inline-flex::after {
  @include sable.layo-display(inline-flex);
}
.table,
.before\:table::before,
.after\:table::after {
  @include sable.layo-display(table);
}
.inline-table,
.before\:inline-table::before,
.after\:inline-table::after {
  @include sable.layo-display(inline-table);
}
.grid,
.before\:grid::before,
.after\:grid::after {
  @include sable.layo-display(grid);
}
.inline-grid,
.before\:inline-grid::before,
.after\:inline-grid::after {
  @include sable.layo-display(inline-grid);
}
.hidden,
.before\:hidden::before,
.after\:hidden::after {
  @include sable.layo-display(none);
}

.float-right{
  @include sable.layo-float(right);
}
.float-left {
  @include sable.layo-float(left);
}
.float-none {
  @include sable.layo-float(none);
}

.clear-left {
  @include sable.layo-clear(left);
}
.clear-right{
  @include sable.layo-clear(right);
}
.clear-both {
  @include sable.layo-clear(both);
}
.clear-none {
  @include sable.layo-clear(none);
}

.overflow-auto,
.before\:overflow-auto::before,
.after\:overflow-auto::after {
  @include sable.layo-overflow(auto);
}
.overflow-hidden,
.before\:overflow-hidden::before,
.after\:overflow-hidden::after {
  @include sable.layo-overflow(hidden);
}
.overflow-clip,
.before\:overflow-clip::before,
.after\:overflow-clip::after {
  @include sable.layo-overflow(clip);
}
.overflow-visible,
.before\:overflow-visible::before,
.after\:overflow-visible::after {
  @include sable.layo-overflow(visible);
}
.overflow-scroll,
.before\:overflow-scroll::before,
.after\:overflow-scroll::after {
  @include sable.layo-overflow(scroll);
}

.static,
.before\:static::before,
.after\:static::after {
  @include sable.layo-position(static);
}
.fixed,
.before\:fixed::before,
.after\:fixed::after {
  @include sable.layo-position(fixed);
}
.absolute,
.before\:absolute::before,
.after\:absolute::after {
  @include sable.layo-position(absolute);
}
.relative,
.before\:relative::before,
.after\:relative::after {
  @include sable.layo-position(relative);
}
.sticky,
.before\:sticky::before,
.after\:sticky::after {
  @include sable.layo-position(sticky);
}

.visible,
.before\:visible::before,
.after\:visible::after {
  @include sable.layo-visibility(visible);
}
.invisible,
.before\:invisible::before,
.after\:invisible::after {
  @include sable.layo-visibility(hidden);
}
.collapse,
.before\:collapse::before,
.after\:collapse::after {
  @include sable.layo-visibility(collapse);
}

.top-0,
.before\:top-0::before,
.after\:top-0::after {
  @include sable.layo-top(0);
}
.right-0,
.before\:right-0::before,
.after\:right-0::after {
  @include sable.layo-right(0);
}
.bottom-0,
.before\:bottom-0::before,
.after\:bottom-0::after {
  @include sable.layo-bottom(0);
}
.left-0,
.before\:left-0::before,
.after\:left-0::after {
  @include sable.layo-left(0);
}
.inset-0,
.before\:inset-0::before,
.after\:inset-0::after {
  @include sable.layo-inset(0);
}

@each $bpName, $width in sable.$fun-breakpoints {
  @media (min-width: #{$width}) {
    .#{$bpName}\:container {
      // xs (extra small)
      @include sable.size-width(100%);
      // sm (small)
      @media only screen and (min-width: 640px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(640, 0.96) * 1px);
      }
      // md (medium)
      @media only screen and (min-width: 768px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(768, 0.94) * 1px);
      }
      // lg (large) 
      @media only screen and (min-width: 1024px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(1024, 0.92) * 1px);
      }
      // xl (extra large)
      @media only screen and (min-width: 1280px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(1280, 0.9) * 1px);
      }
      // 2xl (extra extra large)
      @media only screen and (min-width: 1536px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(1536, 0.88) * 1px);
      }
      // 3xl
      @media only screen and (min-width: 1920px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(1920, 0.86) * 1px);
      }
      // 4xl
      @media only screen and (min-width: 2560px) {
        @include sable.size-max-width(sable.fun-multiWithCeiling(2560, 0.84) * 1px);
      }
    }

    .#{$bpName}\:block,
    .#{$bpName}\:before\:block::before,
    .#{$bpName}\:after\:block::after {
      @include sable.layo-display(block);
    }
    .#{$bpName}\:inline,
    .#{$bpName}\:before\:inline::before,
    .#{$bpName}\:after\:inline::after {
      @include sable.layo-display(inline);
    }
    .#{$bpName}\:inline-block,
    .#{$bpName}\:before\:inline-block::before,
    .#{$bpName}\:after\:inline-block::after {
      @include sable.layo-display(inline-block);
    }
    .#{$bpName}\:flex,
    .#{$bpName}\:before\:flex::before,
    .#{$bpName}\:after\:flex::after {
      @include sable.layo-display(flex);
    }
    .#{$bpName}\:inline-flex,
    .#{$bpName}\:before\:inline-flex::before,
    .#{$bpName}\:after\:inline-flex::after {
      @include sable.layo-display(inline-flex);
    }
    .#{$bpName}\:table,
    .#{$bpName}\:before\:table::before,
    .#{$bpName}\:after\:table::after {
      @include sable.layo-display(table);
    }
    .#{$bpName}\:inline-table,
    .#{$bpName}\:before\:inline-table::before,
    .#{$bpName}\:after\:inline-table::after {
      @include sable.layo-display(inline-table);
    }
    .#{$bpName}\:grid,
    .#{$bpName}\:before\:grid::before,
    .#{$bpName}\:after\:grid::after {
      @include sable.layo-display(grid);
    }
    .#{$bpName}\:inline-grid,
    .#{$bpName}\:before\:inline-grid::before,
    .#{$bpName}\:after\:inline-grid::after {
      @include sable.layo-display(inline-grid);
    }
    .#{$bpName}\:hidden,
    .#{$bpName}\:before\:hidden::before,
    .#{$bpName}\:after\:hidden::after {
      @include sable.layo-display(none);
    }

    .#{$bpName}\:overflow-auto,
    .#{$bpName}\:before\:overflow-auto::before,
    .#{$bpName}\:after\:overflow-auto::after {
      @include sable.layo-overflow(auto);
    }
    .#{$bpName}\:overflow-hidden,
    .#{$bpName}\:before\:overflow-hidden::before,
    .#{$bpName}\:after\:overflow-hidden::after {
      @include sable.layo-overflow(hidden);
    }
    .#{$bpName}\:overflow-clip,
    .#{$bpName}\:before\:overflow-clip::before,
    .#{$bpName}\:after\:overflow-clip::after {
      @include sable.layo-overflow(clip);
    }
    .#{$bpName}\:overflow-visible,
    .#{$bpName}\:before\:overflow-visible::before,
    .#{$bpName}\:after\:overflow-visible::after {
      @include sable.layo-overflow(visible);
    }
    .#{$bpName}\:overflow-scroll,
    .#{$bpName}\:before\:overflow-scroll::before,
    .#{$bpName}\:after\:overflow-scroll::after {
      @include sable.layo-overflow(scroll);
    }
    
    .#{$bpName}\:static,
    .#{$bpName}\:before\:static::before,
    .#{$bpName}\:after\:static::after {
      @include sable.layo-position(static);
    }
    .#{$bpName}\:fixed,
    .#{$bpName}\:before\:fixed::before,
    .#{$bpName}\:after\:fixed::after {
      @include sable.layo-position(fixed);
    }
    .#{$bpName}\:absolute,
    .#{$bpName}\:before\:absolute::before,
    .#{$bpName}\:after\:absolute::after {
      @include sable.layo-position(absolute);
    }
    .#{$bpName}\:relative,
    .#{$bpName}\:before\:relative::before,
    .#{$bpName}\:after\:relative::after {
      @include sable.layo-position(relative);
    }
    .#{$bpName}\:sticky,
    .#{$bpName}\:before\:sticky::before,
    .#{$bpName}\:after\:sticky::after {
      @include sable.layo-position(sticky);
    }

    .#{$bpName}\:visible,
    .#{$bpName}\:before\:visible::before,
    .#{$bpName}\:after\:visible::after {
      @include sable.layo-visibility(visible);
    }
    .#{$bpName}\:invisible,
    .#{$bpName}\:before\:invisible::before,
    .#{$bpName}\:after\:invisible::after {
      @include sable.layo-visibility(hidden);
    }
    .#{$bpName}\:collapse,
    .#{$bpName}\:before\:collapse::before,
    .#{$bpName}\:after\:collapse::after {
      @include sable.layo-visibility(collapse);
    }
  }
}

// z-10 ~ z-90
@for $i from 1 through 9 {
  $zi: $i * 10;
  .z-#{$zi} {
    @include sable.layo-z-index($zi);
  }
}
.z-auto {
  @include sable.layo-z-index(auto);
}
.z-0 {
  @include sable.layo-z-index(0);
}
.z-top {
  @include sable.layo-z-index(99);
}
